<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright ɠ2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: rss.php
| CVS Version: 1.00 BETA
| Author: BTomasz92
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

require_once "../../maincore.php";
require_once INFUSIONS."feed_creator/infusion_db.php";
require_once INFUSIONS."feed_creator/feed_config.php";

if (file_exists(INFUSIONS."feed_creator/locale/".$settings['locale'].".php")) {
	include INFUSIONS."feed_creator/locale/".$settings['locale'].".php";
} 
else {
	include INFUSIONS."feed_creator/locale/English.php";
}

$rss_title = $settings['sitename']." - ";
$rss_maxchars = 250;
$rss_changedate = 0;
$rss_ttl = 120;
$rss_content = "";
$rss_mode = 0;

if(!isnum($_GET['mode']))$rss_mode = FC_CONFIG_NEWS;
else $rss_mode = $_GET['mode'];

$result = dbquery("SELECT * FROM ".DB_FEED_CREATOR." LIMIT 1;");
$fc_config = dbarray($result);

function atc($text) {global $rss_content; $rss_content.=$text;}//AddToContent

if($rss_mode & FC_CONFIG_NEWS && $fc_config['fc_config'] & FC_CONFIG_NEWS) {
	$rss_title .= $locale['FC301'];
	$query = "SELECT news_id, news_subject, news_news, news_datestamp FROM ".DB_PREFIX."news WHERE (news_start='0'||news_start<=".time().") AND 
	(news_end='0'||news_end>=".time().") AND news_visibility='0' AND news_draft='0' ORDER BY news_datestamp DESC LIMIT ".$fc_config['fc_count'].";";
	
	$result = dbquery($query);
	while($temp = dbarray($result)) {
		atc("<item>\n<title>".$temp['news_subject']."</title>\n");
		atc("<link>".$settings['siteurl']."news.php?readmore=".$temp['news_id']."</link>\n");
		atc("<pubDate>".date("r", $temp['news_datestamp'])."</pubDate>\n");
		atc("<description>".trimlink(strip_tags($temp['news_news']),$rss_maxchars)."</description>\n</item>\n");
	}
}
elseif($rss_mode & FC_CONFIG_ARTICLES && $fc_config['fc_config'] & FC_CONFIG_ARTICLES) {
	$rss_title .= $locale['FC302'];
	
	$query = "SELECT article_cat_id, article_cat_access FROM ".DB_PREFIX."article_cats WHERE article_cat_access!='0';";
	$result = dbquery($query);
	
	$where = "";
	
	while($temp = dbarray($result)) {
		$where.="AND article_cat_id!='".$temp['article_cat_id']."' ";
	}
	
	$query2 = "SELECT article_id,  article_cat, article_subject, article_snippet, article_datestamp FROM ".DB_PREFIX."articles WHERE article_draft='0' ".$where." ORDER BY article_datestamp DESC LIMIT ".$fc_config['fc_count'].";";
	$result = dbquery($query2);
	while($temp = dbarray($result)) {
		atc("<item>\n<title>".$temp['article_subject']."</title>\n");
		atc("<link>".$settings['siteurl']."articles.php?article_id=".$temp['article_id']."</link>\n");
		atc("<pubDate>".date("r", $temp['article_datestamp'])."</pubDate>\n");
		atc("<description>".trimlink(strip_tags($temp['article_snippet']),$rss_maxchars)."</description>\n</item>\n");
	}
}
elseif($rss_mode & FC_CONFIG_POSTS && $fc_config['fc_config'] & FC_CONFIG_POSTS) {
	$rss_title .= $locale['FC303'];
	$rss_ttl = 15;
	
	$query = "SELECT forum_id, forum_access FROM ".DB_PREFIX."forums WHERE forum_access!='0';";
	$result = dbquery($query);
	
	$where = "";
	$count = 0;
	
	while($temp = dbarray($result)) {
		if($count != 0) $where.="AND forum_id!='".$temp['forum_id']."' ";
		else $where.="WHERE forum_id!='".$temp['forum_id']."' ";
		$count++;
	}
	
	$query2 = "SELECT thread_id, post_id, post_message, post_datestamp FROM ".DB_PREFIX."posts ".$where."ORDER BY post_datestamp DESC LIMIT ".$fc_config['fc_count'].";";
	
	$result = dbquery($query2);
	while($temp = dbarray($result)) {
		$query3 = "SELECT thread_subject FROM ".DB_PREFIX."threads WHERE thread_id='".$temp['thread_id']."';";
		$result2 = dbquery($query3);
		$temp2 = dbarray($result2);
		
		atc("<item>\n<title>".$temp2['thread_subject']."</title>\n");
		atc("<link>".$settings['siteurl']."forum/viewthread.php?thread_id=".$temp['thread_id']."#post_".$temp['post_id']."</link>\n");
		atc("<pubDate>".date("r", $temp['post_datestamp'])."</pubDate>\n");
		atc("<description>".trimlink(strip_tags($temp['post_message']),$rss_maxchars)."</description>\n</item>\n");
	}

}
elseif ($rss_mode & FC_CONFIG_THREADS && $fc_config['fc_config'] & FC_CONFIG_THREADS) {
	$rss_title .= $locale['FC304'];
	$rss_ttl = 30;
	
	$query = "SELECT forum_id, forum_access FROM ".DB_PREFIX."forums WHERE forum_access!='0';";
	$result = dbquery($query);
	
	$where = "";
	$count = 0;
	
	while($temp = dbarray($result)) {
		if($count != 0) $where.="AND forum_id!='".$temp['forum_id']."' ";
		else $where.="WHERE forum_id!='".$temp['forum_id']."' ";
		$count++;
	}
	
	$query2 = "SELECT thread_id, thread_subject, thread_lastpostid, thread_lastpost FROM ".DB_PREFIX."threads ".$where."ORDER BY thread_lastpost DESC LIMIT ".$fc_config['fc_count'].";";
	$result = dbquery($query2);
	
	while($temp = dbarray($result)) {
		$query3 = "SELECT post_message FROM ".DB_PREFIX."posts WHERE post_id='".$temp['thread_lastpostid']."';";
		$result2 = dbquery($query3);
		$temp2 = dbarray($result2);
		
		atc("<item>\n<title>".$temp['thread_subject']."</title>\n");
		atc("<link>".$settings['siteurl']."forum/viewthread.php?thread_id=".$temp['thread_id']."#post_".$temp['thread_lastpostid']."</link>\n");
		atc("<pubDate>".date("r", $temp['thread_lastpost'])."</pubDate>\n");
		atc("<description>".trimlink(strip_tags($temp2['post_message']),$rss_maxchars)."</description>\n</item>\n");
	}
}
elseif ($rss_mode & FC_CONFIG_DOWNLOADS && $fc_config['fc_config'] & FC_CONFIG_DOWNLOADS) {
	$rss_title .= $locale['FC305'];
	
	$query = "SELECT download_cat_id FROM ".DB_PREFIX."download_cats WHERE download_cat_access !='0';";
	$result = dbquery($query);
	
	$where = "";
	$count = 0;
	
	while($temp = dbarray($result)) {
		if($count != 0) $where.="AND download_cat!='".$temp['download_cat_id']."' ";
		else $where.="WHERE download_cat!='".$temp['download_cat_id']."' ";
		$count++;
	}
	
	$query2 = "SELECT download_cat, download_title, download_description, download_datestamp FROM ".DB_PREFIX."downloads ".$where."ORDER BY download_datestamp DESC LIMIT ".$fc_config['fc_count'].";";
	$result = dbquery($query2);
	
	while($temp = dbarray($result)) {
		atc("<item>\n<title>".$temp['download_title']."</title>\n");
		atc("<link>".$settings['siteurl']."downloads.php?cat_id=".$temp['download_cat']."</link>\n");
		atc("<pubDate>".date("r", $temp['download_datestamp'])."</pubDate>\n");
		atc("<description>".trimlink(strip_tags($temp['download_description']),$rss_maxchars)."</description>\n</item>\n");
	}
}
elseif ($rss_mode & FC_CONFIG_IMAGES && $fc_config['fc_config'] & FC_CONFIG_IMAGES) {
	$rss_title .= $locale['FC306'];
	
	$query = "SELECT album_id FROM ".DB_PREFIX."photo_albums WHERE album_access!='0';";
	$result = dbquery($query);
	
	$where = "";
	$count = 0;
	
	while($temp = dbarray($result)) {
		if($count != 0) $where.="AND album_id!='".$temp['album_id']."' ";
		else $where.="WHERE album_id!='".$temp['album_id']."' ";
		$count++;
	}
	
	$query2 = "SELECT photo_id, photo_title, photo_description, photo_datestamp FROM ".DB_PREFIX."photos ".$where."ORDER BY photo_datestamp DESC LIMIT ".$fc_config['fc_count'].";";
	$result = dbquery($query2);
	
	while($temp = dbarray($result)) {
		atc("<item>\n<title>".$temp['photo_title']."</title>\n");
		atc("<link>".$settings['siteurl']."photogallery.php?photo_id=".$temp['photo_id']."</link>\n");
		atc("<pubDate>".date("r", $temp['photo_datestamp'])."</pubDate>\n");
		atc("<description>".trimlink(strip_tags($temp['photo_description']),$rss_maxchars)."</description>\n</item>\n");
	}

}
elseif ($rss_mode & FC_CONFIG_LINKS && $fc_config['fc_config'] & FC_CONFIG_LINKS) {
	$rss_title .= $locale['FC307'];
	
	$query = "SELECT weblink_cat_id FROM ".DB_PREFIX."weblink_cats WHERE weblink_cat_access!='0';";
	$result = dbquery($query);
	
	$where = "";
	$count = 0;
	
	while($temp = dbarray($result)) {
		if($count != 0) $where.="AND weblink_cat!='".$temp['weblink_cat_id']."' ";
		else $where.="WHERE weblink_cat!='".$temp['weblink_cat_id']."' ";
		$count++;
	}
	
	$query2 = "SELECT weblink_cat, weblink_name, weblink_description, weblink_datestamp FROM ".DB_PREFIX."weblinks ".$where."ORDER BY weblink_datestamp DESC LIMIT ".$fc_config['fc_count'].";";
	$result = dbquery($query2);
	
	while($temp = dbarray($result)) {
		atc("<item>\n<title>".$temp['weblink_name']."</title>\n");
		atc("<link>".$settings['siteurl']."weblinks.php?cat_id=".$temp['weblink_cat']."</link>\n");
		atc("<pubDate>".date("r", $temp['weblink_datestamp'])."</pubDate>\n");
		atc("<description>".trimlink(strip_tags($temp['weblink_description']),$rss_maxchars)."</description>\n</item>\n");
	}

}
elseif ($rss_mode & FC_CONFIG_COMMENTS && $fc_config['fc_config'] & FC_CONFIG_COMMENTS) {
	$rss_title .= $locale['FC308'];

	$query2 = "SELECT comment_id, comment_item_id, comment_type, comment_message, comment_datestamp FROM ".DB_PREFIX."comments ORDER BY comment_datestamp DESC LIMIT ".$fc_config['fc_count'].";";
	$result = dbquery($query2);
	
	while($temp = dbarray($result)) {
		switch($temp['comment_type'])
		{
			case 'N'://News
				$query3 = "SELECT news_subject FROM ".DB_PREFIX."news WHERE news_id='".$temp['comment_item_id']."';";
				$result2 = dbquery($query3);
				$temp2 = dbarray($result2);
				atc("<item>\n<title>".$temp2['news_subject']."</title>\n");
				atc("<link>".$settings['siteurl']."news.php?readmore=".$temp['comment_item_id']."</link>\n");
				atc("<pubDate>".date("r", $temp['comment_datestamp'])."</pubDate>\n");
				atc("<description>".trimlink(strip_tags($temp['comment_message']),$rss_maxchars)."</description>\n</item>\n");
				break;
			case 'A'://Articles
				$query3 = "SELECT article_subject FROM ".DB_PREFIX."articles WHERE article_id='".$temp['comment_item_id']."';";
				$result2 = dbquery($query3);
				$temp2 = dbarray($result2);
				atc("<item>\n<title>".$temp2['article_subject']."</title>\n");
				atc("<link>".$settings['siteurl']."articles.php?article_id=".$temp['comment_item_id']."</link>\n");
				atc("<pubDate>".date("r", $temp['comment_datestamp'])."</pubDate>\n");
				atc("<description>".trimlink(strip_tags($temp['comment_message']),$rss_maxchars)."</description>\n</item>\n");
				break;
			case 'P'://Photos
				$query3 = "SELECT photo_title FROM ".DB_PREFIX."photos WHERE photo_id='".$temp['comment_item_id']."';";
				$result2 = dbquery($query3);
				$temp2 = dbarray($result2);
				atc("<item>\n<title>".$temp2['photo_title']."</title>\n");
				atc("<link>".$settings['siteurl']."photogallery.php?photo_id=".$temp['comment_item_id']."</link>\n");
				atc("<pubDate>".date("r", $temp['comment_datestamp'])."</pubDate>\n");
				atc("<description>".trimlink(strip_tags($temp['comment_message']),$rss_maxchars)."</description>\n</item>\n");
				break;
			case 'C'://Custom pages
				$query3 = "SELECT page_title FROM ".DB_PREFIX."custom_pages WHERE page_id='".$temp['comment_item_id']."';";
				$result2 = dbquery($query3);
				$temp2 = dbarray($result2);
				atc("<item>\n<title>".$temp2['page_title']."</title>\n");
				atc("<link>".$settings['siteurl']."viewpage.php?page_id=".$temp['comment_item_id']."</link>\n");
				atc("<pubDate>".date("r", $temp['comment_datestamp'])."</pubDate>\n");
				atc("<description>".trimlink(strip_tags($temp['comment_message']),$rss_maxchars)."</description>\n</item>\n");
				break;
		}
	}

}
else
{
	atc("<item>\n<title>".$locale['FC501']."</title>\n");
	atc("<link>".$settings['siteurl']."</link>\n");
	atc("<description>".$locale['FC502']."</description>\n</item>\n");
}

header('Content-type: text/xml; charset='.$locale['charset']);

echo '<?xml version="1.0"?>
<rss version="2.0">
<channel>
<title>'.$rss_title.'</title>
<link>'.$settings['siteurl'].'</link>
<webMaster>'.$settings['siteemail'].'</webMaster>
<lastBuildDate>'.date("r").'</lastBuildDate>
<generator>PHP-Fusion Feed Creator Infusion</generator>
<ttl>'.$rss_ttl.'</ttl>
'.$rss_content.'
</channel>
</rss>';

?>